import type { EquipmentTypeViewModel } from "../equipmentType/equipmentType.models";

export type PlanTimeDefinition = `${number}-${"d" | "m" | "y"}` | `${number}/${number | "*"}`;

export interface InspectionPlanViewModel {
  id: string;
  title: string;
  inspectionInterval: PlanTimeDefinition;
  remindTime: PlanTimeDefinition;
  version: number;
  created: Date;
  inspectionPoints: InspectionPointViewModel[];
  equipmentTypeId: string;
  equipmentType: EquipmentTypeViewModel;
}

export interface InspectionVersionedPlanViewModel {
  id: string;
  version: number;
  created: Date;
  inspectionPoints: InspectionPointViewModel[];
  equipmentTypeId: string;
  equipmentType: EquipmentTypeViewModel;
}

export interface CreateInspectionPlanViewModel {
  title: string;
  inspectionInterval: PlanTimeDefinition;
  remindTime: PlanTimeDefinition;
  equipmentTypeId: string;
}

export interface UpdateInspectionPlanViewModel {
  id: string;
  title: string;
  inspectionInterval: PlanTimeDefinition;
  remindTime?: PlanTimeDefinition;
}

export interface InspectionPointViewModel {
  id: string;
  title: string;
  description: string;
  type: "iO-niO" | "text" | "number";
}

export interface InspectionViewMoel {
  id: string;
  inspectionVersionedPlanId: string;
  inspectionVersionedPlan: InspectionVersionedPlanViewModel;
  context: string;
  created: Date;
  finished?: Date;
  isOpen: boolean;
  nextInspection?: Date;
  checks: Array<InspectionPointResultViewMoel>;
}

export interface InspectionPointResultViewMoel {
  inspectionId: string;
  inspectionVersionedPlanId: string;
  inspectionVersionedPlan: InspectionVersionedPlanViewModel;
  inspectionPointId: string;
  inspectionPoint: InspectionPointViewModel;
  value: string;
}
